/*
 * GccApplication2.c
 *
 * Created: 13.2.2017 18:11:43
 * Author : xxx
 */ 

#include <avr/io.h>
#include <avr/power.h>
#include <stdio.h>
#include <string.h>
#include <avr/pgmspace.h>
#include <avr/iom644.h>
#include "const.c"
#include "master.c"
#include "rom_dump.c"

// ====================================
// Compile control
// ====================================
#define simulate;

long int tlacitko;
int lcdi;
unsigned char pozicedispl;
unsigned char key;

void lcd_init();			// inicializuje display (4-bit mode)
void lcd_busy();			// ceka az nebude displej busy
void clrhome();				// displej CLR/HOME
void home();				// displej HOME
void co(char znak);			// console out
void crlf();				// nastavi adresu druheho radku
void prtstg(char *text);	// vypisuje string 
void lcd(char x);			// vysle bity XX RS RW XX DB7 6 5 4
void delay(unsigned int d);	// zpozdeni cca 750 us pro d=100
void delay2();				// kratke zpozdeni

// *****************************************************************************

void __attribute__((optimize("O0")))lcd_init()
{
  lcd(3);
  delay(10000);			//puvodne 2000
  lcd(3);
  lcd(3);
  lcd(2);				// function set (jeste 8 bit mode)
  lcd(2);				// function set  HI
  lcd(8);				// function set  LO
  lcd(0);				// disp off ctrl HI
  lcd(8);				// disp off ctrl LO
  lcd(0);				// disp on ctrl, no cursor HI
  lcd(0x0C);			// disp on ctrl, no cursor LO
  clrhome();
}
// *****************************************************************************
void lcd_busy()
{
  int hinib, lonib;
  DDRA = 0xF0;				//umozni cteni z dolni poloviny portu
  PORTA |= 0x0F;			//pullups on
  delay2();
  
  #ifndef simulate
  do
    {
    PORTA &= 0b00111111;		//RS=0
    delay2();
	PORTA |= 0b00100000;		//RW=1
	delay2();
    PORTA |= 0b00010000;		//E=1
    delay2();
    hinib=PINA;
    delay2();
    PORTA &= 0b11101111;		//E=0
    delay2();
    PORTA |= 0b00010000;		//E=1
    delay2();
    lonib=PINA;
    delay2();
    PORTA &= 0b11101111;		//E=0
    }
  while(hinib & 0x08);
  #endif
   PORTA &= 0b11011111;		//RW=0
   delay(2);
   DDRA = 0xFF;				//opet vystup 
}
// *****************************************************************************

void __attribute__((optimize("O0"))) clrhome()
{
  lcd(0);				// CLEARHOME HI
  lcd(1);				// CLEARHOME LO
  delay(10000);
  lcd(0);				// ENTRY MODE HI
  lcd(6);				// ENTRY MODE LO
}
// *****************************************************************************

void home()
{
  lcd(0);
  lcd(2);
}
// *****************************************************************************

void co(char znak) 			// CONSOLE OUT
{
  lcd(((znak>>4) & 0x0F)|0x40);		// zapis HI nibble (RS=1) 
  lcd((znak & 0x0F)|0x40);		// zapis LO nibble (RS=1)
}
// *****************************************************************************

void crlf()
{
  lcd(0x0C);
  lcd(0x00);
}
// *****************************************************************************

void prtstg(char *text)
{
  lcdi=0;
  while(text[lcdi]!=0)
  {
    co(text[lcdi++]);
  }
}
// *****************************************************************************



void __attribute__((optimize("O0"))) lcd(char x)			// vysle bity XX RS RW XX DB7 6 5 4
{
  lcd_busy();				// pocka, az displej nebude BUSY
  delay2();
  PORTA = (x & 0x6F);
  delay2();
  PORTA |= 0b00010000;		//nahodi E
  delay2();
  PORTA &= 0b11101111;    	//shodi E
  delay2();
}
// *****************************************************************************

void delay(unsigned int d)
{
  while(d--);
}
// *****************************************************************************

void delay2()
{
}
// *****************************************************************************


// ====================================
// Mode control
// ====================================
#define	MODE_TI_59	0x0001
#define	MODE_PRINTER	0x0002
#define	MODE_CARD	0x0004
static unsigned mode_flags = MODE_TI_59;

// ====================================
// card file names
// ====================================
static char card_input[1024] = "";
static char card_output[1024] = "card.bin";
// ====================================
// CPU state variables
// ====================================
static struct {
	// registers
	unsigned char A[16], B[16], C[16], D[16], E[16];
	// keyboard map
	#define	KN_BIT	0
	#define	KO_BIT	1
	#define	KP_BIT	2
	#define	KQ_BIT	3
	#define	KR_BIT	4
	#define	KS_BIT	5
	#define	KT_BIT	6
	unsigned char key[16];
	// bit registers
	unsigned short KR, SR, fA, fB;
	// EXT signal (used for data exchange)
	unsigned short EXT;
	// PREG temporary register (used for direct PC control)
	unsigned short PREG;
	// ALU output signal (used for data exchange)
	unsigned char Sout[16];
	// various CPU flags
	#define	FLG_IDLE	0x0001
	#define	FLG_HOLD	0x0002
	#define	FLG_JUMP	0x0004
	#define	FLG_RCL_SHIFT	4
	#define	FLG_RECALL	0x0010
	#define	FLG_STORE	0x0020
	#define	FLG_RAM_OP	0x0040
	#define	FLG_RAM_READ	0x0080
	#define	FLG_RAM_WRITE	0x0100
	#define	FLG_EXT_VALID	0x0200
	#define	FLG_IO_VALID	0x0400
	#define	FLG_COND	0x0800 // must be here for easy jump processing...
	#define	FLG_DISP	0x1000
	#define	FLG_DISP_C	0x4000 // must be here for easy BUSY processing...
	#define	FLG_BUSY	0x8000
	unsigned short flags;
	// R5 ALU register
	unsigned char R5;
	// cycle digit counter
	unsigned char digit;
	// CPU cycle counter (used to simulate real CPU frequency)
	unsigned cycle;
	// SCOM's & firstROM's address counter = program counter
	unsigned short addr;
	// SCOM register addressing
	unsigned char REG_ADDR;
	// RAM register addressing
	unsigned char RAM_ADDR, RAM_OP;
	// Library module addressing
	unsigned short LIB;
	// printer support
	char PRN_BUF[20];
	unsigned char PRN_PTR;
	unsigned PRN_BUSY;
	// card support
	#define	CRD_LEN	(4+30*8+2)
	unsigned char CRD_PTR;
	unsigned char CRD_BUF[CRD_LEN]; // 246 bytes
	unsigned char CRD_FLAGS;
	#define	CRD_READ	0x01
	#define	CRD_WRITE	0x02
} cpu;
#define	CPU_FREQ	455000	//[Hz]
#define	EMUL_TICK	20	//[ms]
#define	EMUL_CYCLE	((EMUL_TICK * CPU_FREQ) / 2 / 16 / 1000)
// printer real speed emulation
//#define	PRN_BUSY_CYCLE	0
// printer advance can't be fast when using buttons ADVANCE/Adv; calc sends ADV instuction all the time these buttons are held
#define	PRN_BUSY_CYCLE	((150 * CPU_FREQ) / 2 / 16 / 1000)

#define	CARD_INSERTED	(cpu.key[10] & (1 << KR_BIT))
#define	PRN_CONNECTED	(cpu.key[0] & (1 << KP_BIT))
#define	PRN_TRACE	(cpu.key[15] & (1 << KP_BIT))
#define	PRN_ADVANCE	(cpu.key[12] & (1 << KN_BIT))
#define	PRN_PRINT	(cpu.key[12] & (1 << KP_BIT))

// SCOM registers
unsigned char SCOM[16][16];

// RAM registers
unsigned char RAM[120][16];  //puv120 16

// mask definitions
typedef struct {
	unsigned char start, end, cpos, cval;
} mask_type;
static const mask_type mask_info[16] = {
	{-1, 0,  0,   0},
	{0, 15,  0,   0}, // ALL
	{0,  0,  0,   0}, // DPT
	{0,  0,  0,   1}, // DPT 1
	{0,  0,  0, 0xC}, // DPT C
	{3,  3,  3,   1}, // LLSD 1
	{1,  2,  1,   0}, // EXP
	{1,  2,  1,   1}, // EXP 1
	{-1, 0,  0,   0},
	{3, 15,  3,   0}, // MANT
	{-1, 0,  0,   0},
	{3, 15,  3,   5}, // MLSD 5
	{1, 15,  1,   0}, // MAEX
	{1, 15,  3,   1}, // MLSD 1
	{1, 15, 15,   1}, // MMSD 1
	{1, 15,  1,   1}  // MAEX 1
};
// ROM data (linked to romdump2.c)
extern const unsigned short ROM[0x2000];

// Library module data (linked to Master.c)
extern const unsigned char LIB[5000];
extern const char libtoken[100][8];

// SCOM constant data (linked to Const.c)
extern const unsigned char CONSTANT[64][16];

static const char PRN_CODE[64] = {
	' ','0','1','2','3','4','5','6',
	'7','8','9','A','B','C','D','E',
	'-','F','G','H','I','J','K','L',
	'M','N','O','P','Q','R','S','T',
	'.','U','V','W','X','Y','Z','+',
	'x','*','s','p','e','(',')',',',
	'^','%','_','/','=','\'',0x9E,'&',
	'z','?',':','!',']',0x7F,'[','S'
};

static const struct {
	unsigned char code;
	char str[3];
	} PRN_STR[] = {
	{0x00, "   "},
	{0x11, " = "},
	{0x12, " - "},
	{0x13, " + "},
	{0x16, " / "},
	{0x17, " x "},
	{0x1A, "xsY"}, //x_sqrt_Y
	{0x1B, "Y^x"}, //Yx_
	{0x21, "CLR"},
	{0x22, "INV"},
	{0x23, "DPT"},
	{0x26, "CE "},
	{0x27, "+/-"},
	{0x2D, "EE "},
	{0x31, "e^x"}, // ex_
	{0x33, "x^2"}, // x2_
	{0x36, "1/x"},
	{0x3C, "sX "}, // sqrt_X_
	{0x3D, "X_Y"}, // X exchange Y ??
	{0x51, "LNX"},
	{0x53, "PRM"},
	{0x54, " % "},
	{0x56, "COS"},
	{0x57, "SIN"},
	{0x5D, "TAN"},
	{0x61, "SUM"},
	{0x66, "STO"},
	{0x67, "pi "}, //_pi_
	{0x68, "RCL"},
	{0x69, "S+ "},
	{0x70, "ERR"},
	{0x71, " { "},
	{0x72, " ) "},
	{0x73, "LRN"},
	{0x74, "RUN"},
	{0x76, "HLT"},
	{0x78, "STP"},
	{0x7A, "GTO"},
	{0x7C, "IF "},
	{0, {0}}
};
// ====================================
// ALU functions
// ====================================
// ALU block
// ------------------------------------
enum {ALU_ADD, ALU_SHL, ALU_SUB, ALU_SHR};
#define	ALU_SHIFT	ALU_SHL
// ------------------------------------
static void Alu (unsigned char *dst, unsigned char *srcX, unsigned char *srcY, const mask_type *mask, unsigned char flags,unsigned char memorytype,int ix2) {

	unsigned char carry = 0;
	unsigned char shl = 0;
	int i;
	for (i = 0; i <= 15; i++) {
		unsigned char sum = 0, shr = 0;
		if (i == mask->start)
		shl = carry = 0;
		if (srcY)
		if(!memorytype)
		  sum += srcY[i];
	    else
		  sum += pgm_read_byte(&(CONSTANT[ix2][i]));
		
		if (i == mask->cpos)
		sum |= mask->cval;
		shr = sum;
		sum += carry;
		if (flags >= ALU_SUB)
		sum = -sum;
		if (srcX) 
		{
		  sum += srcX[i];
		  shr |= srcX[i];
		}
		cpu.Sout[i] = (sum & 0x0F);
		if (!i) {
			if ((carry = (sum >= 0x10)))
			sum &= 0x0F;
			} else {
			if ((carry = (sum >= 10))) {
				if (flags < ALU_SUB)
				sum -= 10;
				else
				sum += 10;
			}
		}
		// write result to destination
		if (i >= mask->start && i <= mask->end) {
			if (i == mask->start)
			cpu.R5 = sum;
			if (dst) {
				if (flags == ALU_SHL)
				dst[i] = shl;
				else
				if (flags == ALU_SHR) {
					if (i > mask->start)
					dst[i-1] = shr;
					if (i == mask->end)
					dst[i] = 0;
				} else
				dst[i] = sum;
				shl = sum;
			}
			if (i == mask->end && !(flags & ALU_SHIFT) && carry)
			cpu.flags &= ~FLG_COND;
		}
	}
}

// ------------------------------------
// Exchange value
// ------------------------------------
static void Xch (unsigned char *src1, unsigned char *src2, const mask_type *mask) {
	int i;
	for (i = mask->start; i <= mask->end; i++) {
		unsigned char tmp;
		tmp = src1[i];
		src1[i] = src2[i];
		src2[i] = tmp;
	}
}

// ************************************
// main CPU function
// executes instructions
// ************************************
int execute (unsigned short opcode) {
	
	int iix2;		//first index for PROGMEM construction
	// process PREG address change
	if (cpu.PREG & 0x1) {
		// PREG
		cpu.addr = cpu.PREG >> 3;
		cpu.PREG = 0;
		return 0;
	}
	// update digit counter
	if (cpu.digit)
	cpu.digit--;
	else
	cpu.digit = 15;
	// update instruction cycle counter
	if (cpu.flags & FLG_IDLE)
	cpu.cycle += 4;
	else
	cpu.cycle++;
	// clear HOLD bit
	cpu.flags &= ~FLG_HOLD;
	// process PREG bit
	if (cpu.KR & 0x2) {
		cpu.PREG = (cpu.KR >> 1) | (cpu.KR << 15);
		cpu.KR &= ~0x2;
	}
	// init EXT
	if (cpu.flags & FLG_EXT_VALID)
	cpu.flags &= ~FLG_EXT_VALID;
	else
	cpu.EXT = 0;

	// init IO (ALU out)
	if (cpu.flags & FLG_IO_VALID)
	cpu.flags &= ~FLG_IO_VALID;
	else
	memset (cpu.Sout, 0, sizeof (cpu.Sout));

	// process opcode
	if (opcode & 0x1000) {
		// ================================
		// jump
		// ================================
		cpu.flags |= FLG_JUMP;
		if (!((cpu.flags ^ opcode) & FLG_COND)) {
			// COND is same as bit in opcode
			unsigned short offs = (opcode >> 1) & 0x3FF;
			if (opcode & 0x0001)
			cpu.addr -= offs;
			else
			cpu.addr += offs;
		} else
		cpu.addr++;
		return 2;
	}
	if (cpu.flags & FLG_JUMP) {
		// COND is set again after last jump in series
		cpu.flags &= ~FLG_JUMP;
		cpu.flags |= FLG_COND;
	}
	switch (opcode & 0x0F00) {
		// ================================
		// flag operations
		// ================================
		case 0x0000:
		{
			unsigned bit = (opcode >> 4) & 0x000F;
			unsigned mask = 1 << bit;
			switch (opcode & 0x000F) {
				case 0x0000:
				// TEST FLAG A
				if (cpu.fA & mask)
				cpu.flags &= ~FLG_COND;
				break;
				case 0x0001:
				// SET FLAG A
				cpu.fA |= mask;
				break;
				case 0x0002:
				// ZERO FLAG A
				cpu.fA &= ~mask;
				break;
				case 0x0003:
				// INVERT FLAG A
				cpu.fA ^= mask;
				break;
				case 0x0004:
				// EXCH. FLAG A B
				if ((cpu.fA ^ cpu.fB) & mask) {
					cpu.fA ^= mask;
					cpu.fB ^= mask;
				}
				break;
				case 0x0005:
				// SET FLAG KR
				cpu.KR |= mask;
				break;
				case 0x0006:
				// COPY FLAG B->A
				if ((cpu.fA ^ cpu.fB) & mask)
				cpu.fA ^= mask;
				break;
				case 0x0007:
				// REG 5->FLAG A S0 S3
				cpu.fA = (cpu.fA & ~0x001E) | ((cpu.R5 & 0x000F) << 1);
				break;
				case 0x0008:
				// TEST FLAG B
				if (cpu.fB & mask)
				cpu.flags &= ~FLG_COND;
				// IO write control
				if (cpu.flags & FLG_STORE)										//!!!!!!!!!!!! fixed error !!!!!!!!!!!
				{
					cpu.flags &= ~FLG_STORE;
					memset (cpu.Sout, 0, sizeof (cpu.Sout));
					memcpy (SCOM[cpu.REG_ADDR], cpu.Sout, sizeof (cpu.Sout));	//!!!!!!!!!!!! fixed error !!!!!!!!!!!
				}
				break;
				case 0x0009:
				// SET FLAG B
				cpu.fB |= mask;
				break;
				case 0x000A:
				// ZERO FLAG B
				cpu.fB &= ~mask;
				break;
				case 0x000B:
				// INVERT FLAG B
				cpu.fB ^= mask;
				break;
				case 0x000C:
				// COMPARE FLAG A B
				if (!((cpu.fA ^ cpu.fB) & mask))
				cpu.flags &= ~FLG_COND;
				break;
				case 0x000D:
				// ZERO FLAG KR
				cpu.KR &= ~mask;
				break;
				case 0x000E:
				// COPY FLAG A->B
				if ((cpu.fA ^ cpu.fB) & mask)
				cpu.fB ^= mask;
				break;
				case 0x000F:
				// REG 5->FLAG B S0 S3
				cpu.fB = (cpu.fB & ~0x001E) | ((cpu.R5 & 0x000F) << 1);
				break;
			}
		}
		break;
		// ================================
		// keyboard operations
		// ================================
		case 0x0800:
		{
			unsigned char mask;
			// get pressed key(s) mask
			mask = (((opcode & 0x07) | ((opcode >> 1) & 0x78)) ^ 0x7F) & cpu.key[cpu.digit];
			// check if more than 1 key is pressed
			if (mask & (mask - 1))
			mask = 0;
			if (!(opcode & 0x0008)) {
				// scan all keyboard
				// scan current row
				if (cpu.key[cpu.digit] & mask) {
					unsigned char bit = 0;
					// get bit position
					while (!(mask & 1)) {
						bit++;
						mask >>= 1;
					}
					// clear COND
					cpu.flags &= ~FLG_COND;
					// set result to KR
					cpu.KR = /*(cpu.KR & ~0x07F0) |*/ (cpu.digit << 4) | ((bit << 8) & 0x0700);
				} else
				if (cpu.digit) {
					// wait for digit 0 counter - end of scan
					cpu.flags |= FLG_HOLD;
					return 11;
				}
				} else {
				// scan current row and update COND
				if (cpu.key[cpu.digit] & mask)
				cpu.flags &= ~FLG_COND;
			}
		}
		break;
		// ================================
		// wait operations
		// ================================
		case 0x0A00:
		switch (opcode & 0x000F) {
			case 0x0000:
			// wait for digit
			if (cpu.digit != ((opcode >> 4) & 0x000F)) {
				cpu.flags |= FLG_HOLD;
				return 12;
			}
			break;
			case 0x0001:
			// Zero Idle
			cpu.flags &= ~FLG_IDLE;
			break;
			case 0x0002:
			// CLFA
			cpu.fA = 0;
			break;
			case 0x0003:
			// Wait Busy
			// !!!!!!!!!!!!!!!!!!!!!!!!!#warning "Unknown behaviour..."
			break;
			case 0x0004:
			// INCKR
			cpu.KR += 0x0010;
			if (!(cpu.KR & 0xFFF0))
			cpu.KR ^= 0x0001;
			// IO write control
			if (cpu.flags & FLG_STORE)										//!!!!!!!!!!!! fixed error Op00 !!!!!!!!!!!
			{
				cpu.flags &= ~FLG_STORE;
				memset (cpu.Sout, 0, sizeof (cpu.Sout));
				memcpy (SCOM[cpu.REG_ADDR], cpu.Sout, sizeof (cpu.Sout));	//!!!!!!!!!!!! fixed error Op00 !!!!!!!!!!!
			}
			break;
			case 0x0005:
			// TKR
			if (cpu.KR & (1 << ((opcode >> 4) & 0x000F)))
			cpu.flags &= ~FLG_COND;
			break;
			case 0x0006:
			// FLGR5
			if (opcode & 0x0010) {
				cpu.R5 = (cpu.fB >> 1) & 0x000F;
				} else {
				cpu.R5 = (cpu.fA >> 1) & 0x000F;
			}
			break;
			case 0x0007:
			// Number
			cpu.R5 = (opcode >> 4) & 0x000F;
			// IO write control
			if (cpu.flags & FLG_STORE)										//!!!!!!!!!!!! fixed error RST !!!!!!!!!!!
			{	
				cpu.flags &= ~FLG_STORE;
				memset (cpu.Sout, 0, sizeof (cpu.Sout));
				memcpy (SCOM[cpu.REG_ADDR], cpu.Sout, sizeof (cpu.Sout));	//!!!!!!!!!!!! fixed error RST !!!!!!!!!!!
			}
			break;
			case 0x0008:
			// KRR5/R5KR + peripherals
			switch (opcode & 0x00F0) {
				case 0x0000:
				// KRR5
				cpu.R5 = (cpu.KR >> 4) & 0x000F;
				break;
				case 0x0010:
				// R5KR
				cpu.KR = (cpu.KR & ~0x00F0) | (cpu.R5 << 4);
				break;
				case 0x0020:
				// READ
				//	      cpu.EXT = (card_read () << 4);
				cpu.EXT = cpu.CRD_BUF[cpu.CRD_PTR++] << 4;
				cpu.flags |= FLG_EXT_VALID;
				break;
				case 0x0030:
				// WRITE
				//	      card_write (cpu.KR >> 4)
				cpu.CRD_BUF[cpu.CRD_PTR++] = (cpu.KR >> 4);
				break;
				case 0x0040:
				// CRDOFF
				//if (cpu.CRD_FLAGS & CRD_WRITE) {
				//	FILE *f;
				//	if ((f = fopen (card_output, "r+b")) == NULL)
					//f = fopen (card_output, "wb");
					//if (f == NULL) {
						//fprintf (stderr, "Can't access file %s!\n", card_output);
						//} else {
						//fseek (f, CRD_LEN * ((cpu.CRD_BUF[2] & 0x0F) / 3), SEEK_SET);
						//fwrite (cpu.CRD_BUF, CRD_LEN, 1, f);
						//fclose (f);
					//}
				//} else
				//if (cpu.CRD_FLAGS & CRD_READ) {
				//	cpu.CRD_BUF[2] += 3;
				//}
				cpu.CRD_FLAGS = 0;
				cpu.CRD_PTR = 0;
				// clear card switch
				if ((mode_flags & MODE_TI_59))
				// TI-59: D10-KR card switch normally closed
				cpu.key[10] |= (1 << KR_BIT);
				break;
				case 0x0050:
				// CRDREAD
				//if (!cpu.CRD_FLAGS) {
				//	FILE *f;
				//	if ((f = fopen (card_input, "rb")) == NULL) {
				//		fprintf (stderr, "Can't open file %s!\n", card_input);
				//		break;
				//	}
				//	fseek (f, CRD_LEN * ((cpu.CRD_BUF[2] & 0x0F) / 3), SEEK_SET);
				//	fread (cpu.CRD_BUF, CRD_LEN, 1, f);
				//	fclose (f);
				//	cpu.CRD_FLAGS = CRD_READ;
					//cpu.CRD_PTR = 0;
				//}
				break;
				case 0x0060:
				// LOAD
				//	      print_char ((cpu.KR >> 4) & 0x3F);
				if (mode_flags & MODE_PRINTER) {
					cpu.PRN_BUF[cpu.PRN_PTR++] = PRN_CODE[(cpu.KR >> 4) & 0x3F];
					if (cpu.PRN_PTR >= sizeof (cpu.PRN_BUF)) cpu.PRN_PTR = 0;
				}
				break;
				case 0x0070:
				// FUNCTION
				//	      print_func ((cpu.KR >> 4) & 0x7F);
				if (mode_flags & MODE_PRINTER) {
					int i;
					unsigned char code = (cpu.KR >> 4) & 0x7F;
					for (i = 0; *PRN_STR[i].str; i++) {
						if (code == PRN_STR[i].code) {
							for (code = 3; code; ) {
								cpu.PRN_BUF[cpu.PRN_PTR++] = PRN_STR[i].str[--code];
								if (cpu.PRN_PTR >= sizeof (cpu.PRN_BUF)) cpu.PRN_PTR = 0;
							}
						}
					}
				}
				break;
				case 0x0080:
				// CLEAR
				// clear printer buffer
				//	      print_clear ();
				if (mode_flags & MODE_PRINTER) {
					memset (cpu.PRN_BUF, ' ', sizeof (cpu.PRN_BUF));
					cpu.PRN_PTR = 0;
				}
				break;
				case 0x0090:
				// STEP
				// decrement printer position
				if (mode_flags & MODE_PRINTER) {
					cpu.PRN_BUF[cpu.PRN_PTR++] = ' ';
					if (cpu.PRN_PTR >= sizeof (cpu.PRN_BUF)) cpu.PRN_PTR = 0;
					if (cpu.PRN_BUSY) {
						if ((cpu.cycle - cpu.PRN_BUSY) < PRN_BUSY_CYCLE) {
							cpu.flags |= FLG_BUSY;
							} else {
							cpu.PRN_BUSY = 0;
						}
					}
				}
				break;
				case 0x00A0:
				// PRINT
				// print data from buffer
				if (mode_flags & MODE_PRINTER) {
					int i;
					fprintf (stderr, "\r\t\t");
					for (i = 20; i; )
					fputc (cpu.PRN_BUF[--i], stderr);
					// force display re-print
					cpu.flags ^= FLG_DISP;
				}
				//break;
				case 0x00B0:
				// PAPER ADVANCE
				// scroll paper in printer
				if (mode_flags & MODE_PRINTER) {
					fputc ('\n', stderr);
					// check if advance buttons (. or @) are pressed
					if ((cpu.key[9] & (1 << 3)) || (cpu.key[0xC] & (1 << 0))) {
						// use real delay for button-driven paper feed
						cpu.PRN_BUSY = cpu.cycle;
						if (!cpu.PRN_BUSY) cpu.PRN_BUSY--;
					}
				}
				break;
				case 0x00C0:
				// CRDWRITE
				if (!cpu.CRD_FLAGS) {
					cpu.CRD_FLAGS = CRD_WRITE;
					//cpu.CRD_PTR = 0;
				}
				break;
				case 0x00F0:
				// RAMOP
				// next IO contains specification for RAM operation
				cpu.flags |= FLG_RAM_OP;
				break;
			}
			break;
			case 0x0009:
			// Set Idle
			cpu.flags |= FLG_IDLE;
			break;
			case 0x000A:
			// CLFB
			cpu.fB = 0;
			break;
			case 0x000B:
			// Test Busy
			if ((cpu.key[cpu.digit] & (1 << KR_BIT)) || (cpu.flags & FLG_BUSY))
			cpu.flags &= ~(FLG_COND | FLG_BUSY);
			break;
			case 0x000C:
			// EXTKR
			cpu.KR = (cpu.KR & 0x000F) | cpu.EXT;
			break;
			case 0x000D:
			// XKRSR
			{
				unsigned short tmp;
				tmp = cpu.KR;
				cpu.KR = cpu.SR;
				cpu.SR = tmp;
			}
			break;
			case 0x000E:
			// NO-OP + peripherals
			switch (opcode & 0x00F0) {
				case 0x0000:
				// FETCH
				cpu.EXT = pgm_read_byte(&(LIB[cpu.LIB++])) << 4;
				cpu.flags |= FLG_EXT_VALID;
				cpu.LIB %= 5000;
				break;
				case 0x0010:
				// LOAD PC
				cpu.LIB /= 10;
				cpu.LIB += ((cpu.KR >> 4) & 0xF) * 1000;
				break;
				case 0x0020:
				// UNLOAD PC
				cpu.EXT = (cpu.LIB % 10) << 4;
				cpu.flags |= FLG_EXT_VALID;
				//cpu.LIB = (cpu.LIB / 10) + ((cpu.LIB % 10) * 1000); // address is not wrapped around
				cpu.LIB /= 10;
				break;
				case 0x0030:
				// FETCH HIGH
				cpu.EXT = pgm_read_byte(&(LIB[cpu.LIB])) & 0xF0;
				cpu.flags |= FLG_EXT_VALID;
				break;
			}
			break;
			case 0x000F:
			// Register
			switch (opcode & 0x00F0) {
				case 0x0000:
				// Store F
				cpu.flags |= FLG_STORE;
				// address is taken from last IO result - digit 0
				cpu.REG_ADDR = cpu.Sout[0];
				break;
				case 0x0010:
				// Recall F
				cpu.flags |= FLG_RECALL;
				// address is taken from last IO result - digit 0
				cpu.REG_ADDR = cpu.Sout[0];
				break;
			}
			break;
		}
		break;
		// ================================
		// ALU operations
		// ================================
		default: {
			const mask_type *mask = &mask_info[(opcode >> 8) & 0x0F];
			static const struct {
				unsigned char *srcX, *srcY;
				unsigned char flags;
				} *alu_inp, ALU_OP[32] = {
				{cpu.A, 0, ALU_ADD},
				{cpu.A, 0, ALU_SUB},
				{0, cpu.B, ALU_ADD},
				{0, cpu.B, ALU_SUB},
				{cpu.C, 0, ALU_ADD},
				{cpu.C, 0, ALU_SUB},
				{0, cpu.D, ALU_ADD},
				{0, cpu.D, ALU_SUB},
				{cpu.A, 0, ALU_SHL},
				{cpu.A, 0, ALU_SHR},
				{0, cpu.B, ALU_SHL},
				{0, cpu.B, ALU_SHR},
				{cpu.C, 0, ALU_SHL},
				{cpu.C, 0, ALU_SHR},
				{0, cpu.D, ALU_SHL},
				{0, cpu.D, ALU_SHR},
				{cpu.A, cpu.B, ALU_ADD},
				{cpu.A, cpu.B, ALU_SUB},
				{cpu.C, cpu.B, ALU_ADD},
				{cpu.C, cpu.B, ALU_SUB},
				{cpu.C, cpu.D, ALU_ADD},
				{cpu.C, cpu.D, ALU_SUB},
				{cpu.A, cpu.D, ALU_ADD},
				{cpu.A, cpu.D, ALU_SUB},
				// following needs special approach...
				// -> variable pointers, RAM/SCOM access, R5 access
				{cpu.A, 0 /*CONSTANT[((cpu.KR >> 5) & 0x78) | ((cpu.KR >> 4) & 0x07)]*/, ALU_ADD}, // IO read
				{cpu.A, 0 /*CONSTANT[((cpu.KR >> 5) & 0x78) | ((cpu.KR >> 4) & 0x07)]*/, ALU_SUB}, // IO read
				{0, 0, ALU_ADD}, // IO read: 0 -> SCOM[cpu.REG_ADDR] | RAM[cpu.RAM_ADDR]
				{0, 0, ALU_SUB},
				{cpu.C, 0 /*CONSTANT[((cpu.KR >> 5) & 0x78) | ((cpu.KR >> 4) & 0x07)]*/, ALU_ADD}, // IO read
				{cpu.C, 0 /*CONSTANT[((cpu.KR >> 5) & 0x78) | ((cpu.KR >> 4) & 0x07)]*/, ALU_SUB}, // IO read
				{0, 0 /*cpu.R5*/, ALU_ADD}, // IO read ??
				{0, 0 /*cpu.R5*/, ALU_SUB} // IO read ??
			};
			static const struct {
				unsigned char *dst;
				char log[4];
				} *alu_out, ALU_DST[8] = {
				{cpu.A, "A"},
				{0, "IO"},
				{0, ""}, // Xch A,B
				{cpu.B, "B"},
				{cpu.C, "C"},
				{0, ""}, // Xch C,D
				{cpu.D, "D"},
				{0, ""}  // Xch A,E
			};
			alu_out = &ALU_DST[opcode & 0x07];
			if ((opcode & 0x07) == 0x01)
			cpu.flags |= FLG_IO_VALID;
			alu_inp = &ALU_OP[(opcode >> 3) & 0x1F];
			iix2=((cpu.KR >> 5) & 0x78) | ((cpu.KR >> 4) & 0x07);
			switch (opcode & 0x00F8) {
				default:
				// generic ALU operation
				Alu (alu_out->dst, alu_inp->srcX, alu_inp->srcY, mask, alu_inp->flags,0,0);
				break;
				// process special cases
				case 0x00C0: // A+-<io>
				Alu (alu_out->dst, cpu.A,CONSTANT[((cpu.KR >> 5) & 0x78) | ((cpu.KR >> 4) & 0x07)], mask, ALU_ADD,1,iix2);
				break;
				case 0x00C8: // A+-<io>
				Alu (alu_out->dst, cpu.A,CONSTANT[((cpu.KR >> 5) & 0x78) | ((cpu.KR >> 4) & 0x07)], mask, ALU_SUB,1,iix2);
				break;
				case 0x00D0: // NO-OP
				// LOAD from IO / mask
				if (cpu.flags & FLG_RECALL) {
					// load from register
					cpu.flags &= ~FLG_RECALL;
					Alu (alu_out->dst, 0, SCOM[cpu.REG_ADDR], mask, ALU_ADD,0,0);
				} else
				if ((cpu.flags & FLG_RAM_READ) && ((mode_flags & MODE_TI_59) || cpu.RAM_ADDR < 60)) {
					cpu.flags &= ~FLG_RAM_READ;
					Alu (alu_out->dst, 0, RAM[cpu.RAM_ADDR], mask, ALU_ADD,0,0);
				} else
				{
					Alu (alu_out->dst, 0, 0, mask, ALU_ADD,0,0);
				}
				break;
				case 0x00D8:
				// LOAD (negative) from mask
				// never used for IO load but IMHO it will work the same way
				Alu (alu_out->dst, 0, 0, mask, ALU_SUB,0,0);
				break;
				case 0x00E0: // C+-<io>
				Alu (alu_out->dst, cpu.C,CONSTANT[((cpu.KR >> 5) & 0x78) | ((cpu.KR >> 4) & 0x07)], mask, ALU_ADD,1,iix2);
				break;
				case 0x00E8: // C+-<io>
				Alu (alu_out->dst, cpu.C,CONSTANT[((cpu.KR >> 5) & 0x78) | ((cpu.KR >> 4) & 0x07)], mask, ALU_SUB,1,iix2);
				break;
				case 0x00F0: // R5->Adder
				case 0x00F8: // not used in TI-58, probably different behavior...
				if (alu_out->dst) {
					int i;
					for (i = mask->start+1; i <= mask->end; i++)
					alu_out->dst[i] = 0;
					alu_out->dst[mask->cpos] = mask->cval;
					alu_out->dst[mask->start] = cpu.R5;
					// make BCD correction
					if (!(opcode & 0x0008))
					Alu (alu_out->dst, 0, alu_out->dst, mask, ALU_ADD,0,0);
					else
					Alu (alu_out->dst, 0, alu_out->dst, mask, ALU_SUB,0,0); // not sure with this...
				}
				break;
			}
			// EXCHANGE instructions
			switch (opcode & 0x0007) {
				case 0x0002: // A<->B
				Xch (cpu.A, cpu.B, mask);
				break;
				case 0x0005: // C<->D
				Xch (cpu.C, cpu.D, mask);
				break;
				case 0x0007: // A<->E
				Xch (cpu.A, cpu.E, mask);
				break;
			}
			// IO write control
			if (cpu.flags & FLG_STORE) {
				cpu.flags &= ~FLG_STORE;
				memcpy (SCOM[cpu.REG_ADDR], cpu.Sout, sizeof (cpu.Sout));
			}
			if (cpu.flags & FLG_RAM_OP) {
				cpu.flags &= ~FLG_RAM_OP;
				cpu.RAM_OP = cpu.Sout[0];
				cpu.RAM_ADDR = /*cpu.IO[5]*100 +*/ cpu.Sout[3]*10 + cpu.Sout[2];
				if (cpu.RAM_OP == 2) {
					// clear 1 memory cell
					memset (RAM[cpu.RAM_ADDR], 0, 16*1);
				} else
				if (cpu.RAM_OP == 4) {
					// clear 10 memory cells
					memset (RAM[cpu.RAM_ADDR], 0, 16*10);
				} else
				if (cpu.RAM_OP == 1) {
					cpu.flags |= FLG_RAM_WRITE;
				} else
				if (cpu.RAM_OP == 0) {
					cpu.flags |= FLG_RAM_READ;
				}
			} else
			if (cpu.flags & FLG_RAM_WRITE) {
				// store to RAM (ALL_MASK)
				cpu.flags &= ~FLG_RAM_WRITE;
				memcpy (RAM[cpu.RAM_ADDR], cpu.Sout, sizeof (cpu.Sout));
			}
		}

		if (!(cpu.flags & FLG_IO_VALID))
		memset (cpu.Sout, 0, sizeof (cpu.Sout));

		break;
	}
	cpu.addr++;
	return 1;
}

//---------------------------------
// CPU Reset
//---------------------------------
static void cpu_reset (void) {
	// reset cpu variables
	memset (&cpu, 0, sizeof (cpu));
	cpu.flags |= FLG_COND | FLG_DISP;
	// TI-58/59 mode
	if ((mode_flags & MODE_TI_59))
	// TI-59: D10-KR card switch normally closed
	cpu.key[10] |= (1 << KR_BIT);
	else
	// TI-58: D7-KR diode
	cpu.key[7] |= (1 << KR_BIT);
	// printer mode
	if (mode_flags & MODE_PRINTER)
	// printer: D0-KP diode
	cpu.key[0] |= (1 << KP_BIT);
	cpu.addr=0;
}
 
 void __attribute__((optimize("O1"))) keyboard()
{
	 //rows 1 to 9 (D1 to D9)
	 switch (cpu.digit)
	 {
		 case 2:
		 PORTA &= 0b01111111;
		 PORTC = 0b11111111;
		 break;
		 case 3:
		 PORTA |= 0b10000000;
		 PORTC = 0b01111111;
		 break;
		 case 4:
		 PORTA |= 0b10000000;
		 PORTC = 0b10111111;
		 break;
		 case 5:
		 PORTA |= 0b10000000;
		 PORTC = 0b11011111;
		 break;
		 case 6:
		 PORTA |= 0b10000000;
		 PORTC = 0b11101111;
		 break;
		 case 7:
		 PORTA |= 0b10000000;
		 PORTC = 0b11110111;
		 break;
		 PORTA |= 0b10000000;
		 case 8:
		 PORTA |= 0b10000000;
		 PORTC = 0b11111011;
		 break;
		 case 9:
		 PORTA |= 0b10000000;
		 PORTC = 0b11111101;
		 break;
		 case 10:
		 PORTA |= 0b10000000;
		 PORTC = 0b11111110;
		 break;
		 default:
		 PORTA |= 0b10000000;
		 PORTC = 0b11111111;
	 }
	 //read columns KO, KP, KQ, KS, KT
	 if((cpu.digit>=2)&&(cpu.digit<=10))
	 {
		 switch(PIND)
		 {
			 case 0xFE:
			 cpu.key[cpu.digit-1]=0x02;
			 break;
			 case 0xFD:
			 cpu.key[cpu.digit-1]=0x04;
			 break;
			 case 0xFB:
			 cpu.key[cpu.digit-1]=0x08;
			 break;
			 case 0xF7:
			 cpu.key[cpu.digit-1]=0x20;
			 break;
			 case 0xEF:
			 cpu.key[cpu.digit-1]=0x40;
			 break;
			 default:
			 cpu.key[cpu.digit-1]=0x00;
		 }
	 }
}
// ************************************************************************
// Application's main
// ************************************************************************
int main (int argc, char *argv[]) {
	
	unsigned short kod,hlp1;
	
	//initialize ports
	DDRA=0xFF;		//port A out (display)
	DDRC=0xFF;		//port C out (keyboard)
	DDRD=0x00;		//port D in  (keyboard)
	PORTD=0xFF;		//enable pullups on port D
	
	//disable JTAG (=enable PORTC bit 2,3,4,5) 
	hlp1= (1<<JTD);
	MCUCR = hlp1;
	MCUCR = hlp1;
	
	//highest speed
	clock_prescale_set(clock_div_1);
	
	//initialize display
	lcd_init();
	home();
	
	//initialize keyboard reading	
   	for (int i=0;i<=16;i++)
	    cpu.key[i]=0;
	
	// reset CPU
	cpu_reset ();

	//emulate 1 instruction
	while (1)
    {	
	  kod=pgm_read_word(&(ROM[cpu.addr]));
	  execute (kod);

    //display
		if (!cpu.digit) {
			static char disp_filter = 0;
			if (cpu.flags & FLG_IDLE) {
				// display enabled
				static unsigned char dA[16], dB[16];
				int i;
				if (cpu.flags & FLG_DISP) {
					// check difference between current and saved registers
					for (i = 13; i >= 2; i--)
					{
						if (dA[i] != cpu.A[i] || dB[i] != cpu.B[i])
						{
							cpu.flags &= ~FLG_DISP;
							break;
						}
					}
					if ((cpu.flags ^ cpu.fA) & FLG_DISP_C)
					cpu.flags &= ~FLG_DISP;
				}
				if (!(cpu.flags & FLG_DISP)) {
					int zero = 1;
					cpu.flags |= FLG_DISP;
					home();
					if (cpu.fA & 0x4000) {
						co ('C');
						cpu.flags |= FLG_DISP_C;
						} else {
						cpu.flags &= ~FLG_DISP_C;
					}
					
					for (i = 13; i >= 2; i--) {
						dA[i] = cpu.A[i];
						dB[i] = cpu.B[i];
						if (i == 3 || cpu.R5 == i || cpu.B[i] >= 8)
						zero = 0;
						if (i == 2)
						zero = 1;
						if (cpu.B[i] == 7 || cpu.B[i] == 3 || (cpu.B[i] <= 4 && zero && !cpu.A[i]))
						co (' ');
						else
						if (cpu.B[i] == 6 || (cpu.B[i] == 5 && !cpu.A[i]))
						co ('-');
						else
						if (cpu.B[i] == 5)
						co ('o');
						else
						if (cpu.B[i] == 4)
						co ('\'');
						else
						if (cpu.B[3] == 2)
						co ('"');
						else {
							co ('0' + cpu.A[i]);
							if (cpu.A[i])
							zero = 0;
						}
						if (cpu.R5 == i)
						co ('.');
					}
				
					//co ('|'); co (' ');
				}
				disp_filter = 0;
			} else
			if (disp_filter < 3)
			disp_filter++;
			else {
				// display disabled
				if ((cpu.flags & FLG_DISP) /*|| (!cpu.fA && (cpu.flags & FLG_DISP_C))*/ || (cpu.fA && !(cpu.flags & FLG_DISP_C))) 
				{
						cpu.flags &= ~FLG_DISP;
					if (cpu.fA)
					{
						home();
						prtstg("C             ");
						home();
						cpu.flags |= FLG_DISP_C;
						} else {
						home();
						prtstg("              ");
						home();
						cpu.flags &= ~FLG_DISP_C;
				    }
				}
	
		        }//else    
		}// if cpudigit
	 
      keyboard();
	}
}
	
